!=======================================================================

SUBROUTINE  TDSTRAIN

  USE PRECISION   , ONLY:                                              &
                          WP     
  USE CONTROL_DATA, ONLY:                                              &
                          KTTO, MZ
  USE AUXIL       , ONLY:                                              &
                          AH, BH, CH
  USE WAVEFIELD   , ONLY:                                              &
                          V, ED

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER :: L

!-----------------------------------------------------------------------


  IF      ( KTTO < 0 ) THEN   ! top boundary is free surface: use AFDA

    ED(0) = CH*( - 11._WP/12._WP * V (0)                               &
                 + 17._WP/24._WP * V (1)                               &
                 +  3._WP/ 8._WP * V (2)                               &
                 -  5._WP/24._WP * V (3)                               &
                 +  1._WP/24._WP * V (4) )

  ELSE IF ( KTTO == 0 ) THEN  ! top boundary is plane of symmetry: use symmetric imaging

    ED(0) = AH*( V (2) - V (1) )                                       &
          + BH*( V (1) - V (0) )

  ELSE                        ! top boundary is 'non-reflecting': use 2nd order FDA
  
    ED(0) = CH*( V (1) - V (0) )

  END IF
      
  DO  L = 1, MZ-2             ! interior FD scheme

    ED(L) = AH*( V (L+2) - V (L-1) )                                   &
          + BH*( V (L+1) - V (L  ) )

  END DO

                              ! bottom boundary is 'non-reflecting': use 2nd order FDA
  L = MZ-1

    ED(L) = CH*( V (L+1) - V (L  ) )


END  SUBROUTINE  TDSTRAIN
