SUBROUTINE PREPARE_FINE_PAR (L, H, Z0)

  USE NRTYPE         , ONLY: WP
  USE MOD_INTEGRATION, ONLY: PTS, PTS2, M1_FINE, RHO_FINE
  USE MOD_INTERFACES , ONLY: FUNC_M1_RHO
  
!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER , INTENT(IN) :: L
  REAL(WP), INTENT(IN) :: H, Z0

  INTEGER              :: LI
  
  REAL(WP)             :: HPTS_H, H2_H, ZSTART, PAR(2), Z

!----------------------------------------------------------------------

  HPTS_H  =  H/REAL(PTS,WP)
  H2_H    = (H - HPTS_H)/2._WP

  ZSTART = Z0 + REAL(L,WP)*H - H2_H

  DO LI = PTS+PTS2, PTS2+1, -1

    Z = ZSTART + REAL(LI-1,WP)*HPTS_H

    PAR = FUNC_M1_RHO (Z)
     M1_FINE (LI) = PAR(1)
    RHO_FINE (LI) = PAR(2)

  END DO

  IF ( L == 0 ) THEN

    DO LI = 1, PTS2
       M1_FINE (LI) =  M1_FINE (PTS+1-LI)
      RHO_FINE (LI) = RHO_FINE (PTS+1-LI)
    END DO

  ELSE

    DO LI = 1, PTS2
    
      Z = ZSTART + REAL(LI-1,WP)*HPTS_H

      PAR = FUNC_M1_RHO (Z)
       M1_FINE (LI) = PAR(1)
      RHO_FINE (LI) = PAR(2)

    END DO

  END IF

END SUBROUTINE PREPARE_FINE_PAR