!-----------------------------------------------------------------------
! subroutine reads program configuration, set some run-time constants 
! and check if some parameters fulfill required conditions
!-----------------------------------------------------------------------
SUBROUTINE SETPARAMS

  USE NRTYPE         , ONLY: WP
  USE MOD_MODEL      , ONLY: H, KEY_Q, MZ, H2, ZMAX
  USE MOD_FILES      , ONLY: MO_FILE_NAME, Q_FILE_NAME
  USE MOD_INTEGRATION, ONLY: PTS
  USE MOD_INTERFACES , ONLY: PRINT_INFO, TEST_PARAMETERS
  USE MOD_PARAMETERIZATION, ONLY: &
                             FRJMAX, FRANGE, FREF, NRFREQ
!----------------------------------------------------------------------

  IMPLICIT NONE

  NAMELIST /CONTROL/ H, ZMAX, PTS, KEY_Q
  
  NAMELIST /OUT_FILES/ MO_FILE_NAME,  Q_FILE_NAME

  NAMELIST /PARAMS/ FRJMAX,FRANGE,FREF, NRFREQ
!----------------------------------------------------------------------

  OPEN  (10, FILE='MODEL.IN', STATUS='OLD' )
    READ(10, NML = CONTROL  )
    READ(10, NML = OUT_FILES)
    READ(10, NML = PARAMS   )
  CLOSE (10)

  !--------------------------------------- set some run-time constants

  MZ = ZMAX/H
 
  H2 = H/2._WP
  
  !------------------------------------ tests of some input parameters
  CALL TEST_PARAMETERS

  !---------------------------------- print info about model on screen
  CALL PRINT_INFO

END SUBROUTINE SETPARAMS

